-- credits go to this excellent fella: https://steamcommunity.com/profiles/76561198062937168
Epic = RegisterMod("The Specialist for Good Items", 1)
local game = Game()
local SaveState = {}

---------------------------------------------------------------
---------------------------Settings----------------------------

-- You can edit these settings directly from this file if you want
-- If you want these settings to save across updates, I highly recommend you have Mod Config Menu installed

-- setting this to "true" will override ModConfig values
local defaultsChanged = false
local EpicSettings = {
    ["BlindBypass"] = false, -- Bypass curse of the blind
    ["QualityThreshold"] = 4, -- Minimum quality required for pog to activate
    ["IgnoreQuality"] = false, -- Ignore items qualities altogether

    ["EnableMusic"] = true
}

---------------------------------------------------------------

-- store as a map
local function cost(name)
    return Isaac.GetCostumeIdByPath("the/specialist_" .. name .. ".anm2");
end
local function itm(name)
    return Isaac.GetCostumeIdByPath("the/items/" .. name .. ".anm2");
end

local danceCostumes = {
    [PlayerType.PLAYER_ISAAC] = cost("isaac"),
    [PlayerType.PLAYER_MAGDALENA] = cost("magdalene"),
    [PlayerType.PLAYER_CAIN] = cost("cain"),
    [PlayerType.PLAYER_JUDAS] = cost("judas"),
    [PlayerType.PLAYER_BLACKJUDAS] = cost("dark_judas"),
    [PlayerType.PLAYER_XXX] = cost("xxx"),
    [PlayerType.PLAYER_EVE] = cost("eve"),
    [PlayerType.PLAYER_SAMSON] = cost("samson"),
    [PlayerType.PLAYER_AZAZEL] = cost("azazer"),
    [PlayerType.PLAYER_LAZARUS] = cost("lazarus"),
    [PlayerType.PLAYER_LAZARUS2] = cost("lazarus2"),
    [PlayerType.PLAYER_EDEN] = cost("eden"),
    [PlayerType.PLAYER_THELOST] = cost("lost"),
    [PlayerType.PLAYER_LILITH] = cost("lilith"),
    [PlayerType.PLAYER_KEEPER] = cost("keeper"),
    [PlayerType.PLAYER_APOLLYON] = cost("apollyon"),
    [PlayerType.PLAYER_THEFORGOTTEN] = cost("forgor_bone"),
    [PlayerType.PLAYER_THESOUL] = cost("forgor_soul"),
    [PlayerType.PLAYER_BETHANY] = cost("bethany"),
    [PlayerType.PLAYER_JACOB] = cost("jacob"),
    [PlayerType.PLAYER_ESAU] = cost("esau"),

    -- Tainted --

    [PlayerType.PLAYER_ISAAC_B] = cost("isaac"),
    [PlayerType.PLAYER_MAGDALENA_B] = cost("magdalene"),
    [PlayerType.PLAYER_CAIN_B] = cost("t_cain"),
    [PlayerType.PLAYER_JUDAS_B] = cost("dark_judas"),
    [PlayerType.PLAYER_XXX_B] = cost("xxx"),
    [PlayerType.PLAYER_EVE_B] = cost("eve"),
    [PlayerType.PLAYER_SAMSON_B] = cost("samson"),
    [PlayerType.PLAYER_AZAZEL_B] = cost("azazer"),
    [PlayerType.PLAYER_LAZARUS_B] = cost("lazarus"),
    [PlayerType.PLAYER_LAZARUS2_B] = cost("lazarus2"),
    [PlayerType.PLAYER_EDEN_B] = cost("eden"),
    [PlayerType.PLAYER_THELOST_B] = cost("lost"),
    [PlayerType.PLAYER_LILITH_B] = cost("lilith"),
    [PlayerType.PLAYER_KEEPER_B] = cost("keeper"),
    [PlayerType.PLAYER_APOLLYON_B] = cost("apollyon"),
    [PlayerType.PLAYER_THEFORGOTTEN_B] = cost("forgor_bone"),
    [PlayerType.PLAYER_THESOUL_B] = cost("forgor_soul"),
    [PlayerType.PLAYER_BETHANY_B] = cost("bethany"),
    [PlayerType.PLAYER_JACOB_B] = cost("jacob"),
    [PlayerType.PLAYER_JACOB2_B] = cost("lost"),

    DEFAULT = cost("isaac")
}

-- the api is retarded
local danceItems = {
    [CollectibleType.COLLECTIBLE_BINKY] = itm("binky")
}

---------------------------------------------------------------
---------------------------Mod API-----------------------------

local function addAnimation(table, type, costume, override)
    if override then
        table[type] = costume
    elseif danceCostumes[playerType] == nil then
        table[type] = costume
    else
        return false
    end
    return true
end
local function removeAnimation(table, type)
    -- not sure if this is applicable here
    table[type] = nil;
end

SpecialistModAPI = {};

-- In MC_POST_GAME_STARTED
-- Don't forget the ':'!

-- returns true if success; false if failure
function SpecialistModAPI:AddDanceCostume(playerType --[[PlayerType]] , costumeID --[[int]] , override --[[boolean]] )
    return addAnimation(danceCostumes, playerType, costumeID, override);
end
function SpecialistModAPI:RemoveDanceCostume(playerType --[[PlayerType]] )
    return removeAnimation(danceCostumes, playerType);
end

-- returns true if success; false if failure
function SpecialistModAPI:AddItemCostume(collectibleType --[[CollectibleType]] , costumeID --[[int]] , override --[[boolean]] )
    return addAnimation(danceItems, collectibleType, costumeID, override);
end
function SpecialistModAPI:RemoveItemCostume(collectibleType --[[CollectibleType]] )
    return removeAnimation(danceItems, collectibleType);
end

---------------------------------------------------------------

local playerAlias = {
    [PlayerType.PLAYER_ISAAC] = "isaac",
    [PlayerType.PLAYER_MAGDALENA] = "magdalene",
    [PlayerType.PLAYER_CAIN] = "cain",
    [PlayerType.PLAYER_JUDAS] = "judas",
    [PlayerType.PLAYER_XXX] = "xxx",
    [PlayerType.PLAYER_EVE] = "eve",
    [PlayerType.PLAYER_SAMSON] = "samson",
    [PlayerType.PLAYER_AZAZEL] = "azazel",
    [PlayerType.PLAYER_LAZARUS] = "lazarus",
    [PlayerType.PLAYER_EDEN] = "eden",
    [PlayerType.PLAYER_THELOST] = "lost",
    [PlayerType.PLAYER_LAZARUS2] = "deadlazarus",
    [PlayerType.PLAYER_BLACKJUDAS] = "darkjudas",
    [PlayerType.PLAYER_LILITH] = "lilith",
    [PlayerType.PLAYER_KEEPER] = "keeper",
    [PlayerType.PLAYER_APOLLYON] = "apollyon",
    [PlayerType.PLAYER_THEFORGOTTEN] = "forgotten",
    -- double character
    -- [PlayerType.PLAYER_THESOUL] = "",
    [PlayerType.PLAYER_BETHANY] = "bethany",
    [PlayerType.PLAYER_JACOB] = "jacob",
    -- double character
    -- [PlayerType.PLAYER_ESAU] = "",
    [PlayerType.PLAYER_ISAAC_B] = "tisaac",
    [PlayerType.PLAYER_MAGDALENA_B] = "tmagdalene",
    [PlayerType.PLAYER_CAIN_B] = "tcain",
    [PlayerType.PLAYER_JUDAS_B] = "tjudas",
    [PlayerType.PLAYER_XXX_B] = "txxx",
    [PlayerType.PLAYER_EVE_B] = "teve",
    [PlayerType.PLAYER_SAMSON_B] = "tsamson",
    [PlayerType.PLAYER_AZAZEL_B] = "tazazel",
    [PlayerType.PLAYER_LAZARUS_B] = "tlazarus",
    [PlayerType.PLAYER_EDEN_B] = "teden",
    [PlayerType.PLAYER_THELOST_B] = "tlost",
    [PlayerType.PLAYER_LILITH_B] = "tlilith",
    [PlayerType.PLAYER_KEEPER_B] = "tkeeper",
    [PlayerType.PLAYER_APOLLYON_B] = "tapollyon",
    [PlayerType.PLAYER_THEFORGOTTEN_B] = "tforgotten",
    [PlayerType.PLAYER_BETHANY_B] = "tbethany",
    [PlayerType.PLAYER_JACOB_B] = "tjacob",
    [PlayerType.PLAYER_LAZARUS2_B] = "tdeadlazarus",
    [PlayerType.PLAYER_JACOB2_B] = "tghostjacob"
    -- double character
    -- [PlayerType.PLAYER_THESOUL_B] = ""
}
local function randomMusicIdForPlayerType(ptype)
    local typeAlias = playerAlias[ptype];
    local isPresent = Isaac.GetMusicIdByName("s_" .. typeAlias) ~= -1;
    if not isPresent then
        return -1;
    end
    local possibleSongs = {};
    local i = 0;
    -- i = 0 | s_player
    -- i = 1 | s_player1
    -- i = 2 | s_player2
    -- ...
    while Isaac.GetMusicIdByName("s_" .. typeAlias .. tostring(i == 0 and "" or i)) ~= -1 do
        table.insert(possibleSongs, Isaac.GetMusicIdByName("s_" .. typeAlias .. tostring(i == 0 and "" or i)));
        i = i + 1;
    end
    return possibleSongs[math.random(#possibleSongs)];
end

-- Below is a list of item names that the player will pog to.
-- You can edit this list however you like, just remember to keep the format the same and the item names accurate
-- (Set 1 for pog, set 2 for not pog)

local CustomPogList = {
    ["Cricket's Head"] = 1,
    ["Magic Mushroom"] = 1,
    ["Sacred Heart"] = 1,
    ["Brimstone"] = 1
}
local saveThisList = false -- IMPORTANT: Set this to "true", and this list will replace the saved one in-game.

-- btw if you see this reset at any point, it just means the mod updated. It should still be saved in-game though.

---------------------------------------------------------------
---------------------------Defaults----------------------------



--if EpicSettings["BlindBypass"] == true or EpicSettings["QualityThreshold"] ~= 3 or EpicSettings["IgnoreQuality"] == true or
--    saveThisList == true then
--    defaultsChanged = true
--end

---------------------------------------------------------------
------------------------Mod Config Menu------------------------

if ModConfigMenu then

    -- Get max collectible id
    function Epic:GetMaxCollectibleID()
        local id = CollectibleType.NUM_COLLECTIBLES - 1
        local step = 16
        while step > 0 do
            if Isaac.GetItemConfig():GetCollectible(id + step) ~= nil then
                id = id + step
            else
                step = step // 2
            end
        end

        return id
    end

    local EpicName = "Specialist For Good Items"

    ModConfigMenu.UpdateCategory(EpicName, {
        Info = {"The Specialist For Good Items settings."}
    })

    -- Title

    ModConfigMenu.AddText(EpicName, "Settings", function()
        return "The Specialist For Good Items"
    end)
    ModConfigMenu.AddSpace(EpicName, "Settings")

    -- Settings
    ModConfigMenu.AddSetting(EpicName, "Settings", {
        Type = ModConfigMenu.OptionType.BOOLEAN,
        CurrentSetting = function()
            return EpicSettings["BlindBypass"]
        end,
        Display = function()
            local onOff = "False"
            if EpicSettings["BlindBypass"] then
                onOff = "True"
            end
            return 'Bypass "Curse of the Blind": ' .. onOff
        end,
        OnChange = function(currentBool)
            EpicSettings["BlindBypass"] = currentBool
        end,
        Info = {"Dance will activate during Curse of the Blind"}
    })

    ModConfigMenu.AddSetting(EpicName, "Settings", {
        Type = ModConfigMenu.OptionType.NUMBER,
        CurrentSetting = function()
            return EpicSettings["QualityThreshold"]
        end,
        Minimum = 0,
        Maximum = 4,
        Display = function()
            return "Quality Check: " .. EpicSettings["QualityThreshold"]
        end,
        OnChange = function(currentNum)
            EpicSettings["QualityThreshold"] = currentNum
        end,
        Info = {"The minimum item quality needed for dance to activate"}
    })

    ModConfigMenu.AddSpace(EpicName, "Settings")

    ModConfigMenu.AddSetting(EpicName, "Settings", {
        Type = ModConfigMenu.OptionType.BOOLEAN,
        CurrentSetting = function()
            return EpicSettings["IgnoreQuality"]
        end,
        Display = function()
            local onOff = "False"
            if EpicSettings["IgnoreQuality"] then
                onOff = "True"
            end
            return 'Ignore Quality: ' .. onOff
        end,
        OnChange = function(currentBool)
            EpicSettings["IgnoreQuality"] = currentBool
        end,
        Info = {"Dance will ignore the quality system altogether."}
    })

    ModConfigMenu.AddSetting(EpicName, "Settings", {
        Type = ModConfigMenu.OptionType.BOOLEAN,
        CurrentSetting = function()
            return EpicSettings["EnableMusic"]
        end,
        Display = function()
            local onOff = "False"
            if EpicSettings["EnableMusic"] then
                onOff = "True"
            end
            return 'Enable Music: ' .. onOff
        end,
        OnChange = function(currentBool)
            EpicSettings["EnableMusic"] = currentBool
        end,
        Info = {"No music if disabled."}
    })

    -- Customization options

    local savePos = 0
    local hunPos = 1

    for id = 1, Epic:GetMaxCollectibleID() do

        local item = Isaac.GetItemConfig():GetCollectible(id)
        -- print(id)

        savePos = savePos + 1
        if savePos == 101 then
            hunPos = hunPos + 1
            savePos = 1
        end

        local ctgName = tostring(hunPos * 100 - 99) .. '-' .. tostring(hunPos * 100)

        if id == 1 then
            ModConfigMenu.AddText(EpicName, ctgName, function()
                return "Customize settings for any item"
            end)
            ModConfigMenu.AddSpace(EpicName, ctgName)
        end

        if item ~= nil then

            local thisName = item.Name
            local tableIndex = thisName

            -- funny exceptions (for when they gave items the exact same name thanks guys)
            if id == 120 then
                thisName = "Odd Mushroom (Thin)"
                tableIndex = thisName
            elseif id == 121 then
                thisName = "Odd Mushroom (Large)"
                tableIndex = thisName
            elseif id == 656 then
                thisName = "Damocles (Passive)"
                tableIndex = "Damocles"
            end

            -- print(tableIndex)
            if CustomPogList[tableIndex] == nil then
                table.insert(CustomPogList, tableIndex)
                CustomPogList[tableIndex] = 0
            end

            ModConfigMenu.AddSetting(EpicName, ctgName, {
                Type = ModConfigMenu.OptionType.NUMBER,
                CurrentSetting = function()
                    return CustomPogList[tableIndex]
                end,
                Minimum = 0,
                Maximum = 2,
                Display = function()
                    local nChoice = "default"
                    if CustomPogList[tableIndex] == 1 then
                        nChoice = "boogie"
                    elseif CustomPogList[tableIndex] == 2 then
                        nChoice = "not boogie"
                    end
                    return id .. '     ' .. thisName .. ': ' .. nChoice
                end,
                OnChange = function(currentNum)
                    CustomPogList[tableIndex] = currentNum
                end,
                Info = {thisName .. " (quality " .. item.Quality .. ")"}
            })
        end
    end
end

---------------------------------------------------------------
---------------------------Savedata----------------------------

local json = require("json")

function Epic:SaveGame()
    SaveState.Settings = {}
    SaveState.Items = {}

    for i, v in pairs(EpicSettings) do
        SaveState.Settings[tostring(i)] = EpicSettings[i]
    end
    for i, v in pairs(CustomPogList) do
        SaveState.Items[tostring(i)] = CustomPogList[i]
    end
    Epic:SaveData(json.encode(SaveState))
end
Epic:AddCallback(ModCallbacks.MC_PRE_GAME_EXIT, Epic.SaveGame)

function Epic:OnGameStart(isSave)
    if defaultsChanged then
        Epic:SaveGame()
    end

    if Epic:HasData() then
        SaveState = json.decode(Epic:LoadData())

        for i, v in pairs(SaveState.Settings) do
            EpicSettings[tostring(i)] = SaveState.Settings[i]
        end
        for i, v in pairs(SaveState.Items) do
            CustomPogList[tostring(i)] = SaveState.Items[i]
        end

        if CustomPogList["Odd Mushroom"] ~= nil then
            CustomPogList["Odd Mushroom"] = 0
        end
    end
end
Epic:AddCallback(ModCallbacks.MC_POST_GAME_STARTED, Epic.OnGameStart)

---------------------------------------------------------------
------------------------------Main-----------------------------

local weirdExtra
-- fixes double treasure room jingle
local wasPog = false;
-- Add or remove POG costume
function Epic:DoCostume(apply)
    result = false

    for playerNum = 1, game:GetNumPlayers() do
        local player = game:GetPlayer(playerNum)

        local pogCostume = danceCostumes.DEFAULT;
        if danceCostumes[player:GetPlayerType()] ~= nil then
            pogCostume = danceCostumes[player:GetPlayerType()];
        end
        local removeCostume = nil

        local isTaintedCain = player:GetPlayerType() == PlayerType.PLAYER_CAIN_B;

        -- apply
        if pogCostume ~= nil then
            if apply then
                -- play dance
                player:AddNullCostume(pogCostume)

                for itemId, itemCostume in pairs(danceItems) do
                    if player:GetCollectibleNum(itemId, true) > 0 then
                        player:AddNullCostume(itemCostume)
                    end
                end
                result = true

                -- play music
                if EpicSettings["EnableMusic"] then
                    local ptype = player:GetPlayerType();
                    -- if not any of these three
                    if not (ptype == PlayerType.PLAYER_THESOUL or ptype == PlayerType.PLAYER_ESAU or ptype ==
                        PlayerType.PLAYER_THESOUL_B) then

                        local specialist = Isaac.GetMusicIdByName("specialist");
                        local paincialist = Isaac.GetMusicIdByName("paincialist");
                        local customMusic = randomMusicIdForPlayerType(ptype);

                        if customMusic ~= -1 then
                            if MusicManager():GetCurrentMusicID() ~= customMusic then
                                MusicManager():Play(customMusic, 1);
                                wasPog = true;
                            end
                        else
                            if not isTaintedCain then
                                if MusicManager():GetCurrentMusicID() ~= specialist then
                                    MusicManager():Play(specialist, 1);
                                    wasPog = true;
                                end
                            else
                                if MusicManager():GetCurrentMusicID() ~= paincialist then
                                    MusicManager():Play(paincialist, 1);
                                    wasPog = true;
                                end
                            end
                        end
                        -- fix earrape
                        MusicManager():UpdateVolume();
                    end
                end
            else
                player:TryRemoveNullCostume(pogCostume)

                for itemId, itemCostume in pairs(danceItems) do
                    if player:GetCollectibleNum(itemId, true) > 0 then
                        player:TryRemoveNullCostume(itemCostume)
                    end
                end

                if weirdExtra ~= nil then
                    player:TryRemoveNullCostume(weirdExtra)
                end

                if weirdExtra ~= pogCostume then
                    weirdExtra = pogCostume
                end

                result = false

                if EpicSettings["EnableMusic"] and wasPog then
                    Game():GetRoom():PlayMusic();
                    wasPog = false;
                end
            end
        end
    end
    return result
end

---------------------------------------------------------------

local costume = false

-- Pog costume processing
function Epic:OnPogMoment(itemCount)
    if Epic:BlindCheck() then

        local altRoomItems = 0

        -- alt path treasure room
        local isRepStage = game:GetLevel():GetStageType() >= StageType.STAGETYPE_REPENTANCE
        if game:GetRoom():GetType() == RoomType.ROOM_TREASURE and isRepStage then
            altRoomItems = itemCount
        end

        -- print ("isRepStage=",isRepStage,"  roomItems=",roomItems)

        -- Scan entities in room
        local basedRoom = false;
        for i, entity in ipairs(Isaac.FindInRadius(Vector(640, 580), 875, EntityPartition.PICKUP)) do

            -- Only pedestal items
            if entity.Variant == PickupVariant.PICKUP_COLLECTIBLE then

                local id = entity.SubType
                local item = Isaac.GetItemConfig():GetCollectible(id)

                if item ~= nil then
                    local visible = true

                    -- alt path blind
                    if altRoomItems > 0 then
                        visible = Epic:AltBlindCheck(entity, item, altRoomItems)
                    end

                    if visible and item.Quality ~= nil then
                        -- Weird exceptions go first
                        if id == 120 and CustomPogList["Odd Mushroom (Thin)"] == 1 then -- thin odd mushroom
                            -- ADD COSTUME
                            costume = Epic:DoCostume(true)
                            basedRoom = true
                            break
                        elseif id == 121 and CustomPogList["Odd Mushroom (Large)"] == 1 then -- large odd mushroom
                            -- ADD COSTUME
                            costume = Epic:DoCostume(true)
                            basedRoom = true
                            break
                        end

                        -- Check pog list
                        if CustomPogList[item.Name] == 1 then
                            -- ADD COSTUME
                            costume = Epic:DoCostume(true)
                            basedRoom = true
                            break
                        end

                        -- Check item quality
                        if item.Quality >= EpicSettings["QualityThreshold"] and EpicSettings["IgnoreQuality"] == false and
                            CustomPogList[item.Name] ~= 2 then
                            -- ADD COSTUME
                            costume = Epic:DoCostume(true)
                            basedRoom = true
                            break
                        end
                    end

                end
            end
        end
        if not basedRoom then
            Epic:DoCostume(false)
        end
    end
end

---------------------------------------------------------------

-- Scan items
function Epic:ScanItems()
    local number = 0
    for i, entity in ipairs(Isaac.FindInRadius(Vector(640, 580), 875, EntityPartition.PICKUP)) do
        if entity.Variant == PickupVariant.PICKUP_COLLECTIBLE and entity.SubType > 0 then
            number = number + 1
        end
    end
    return number
end

-- Check for curse of the blind
function Epic:BlindCheck()
    if EpicSettings["BlindBypass"] then
        return true
    end

    if game:GetLevel():GetCurses() & 64 ~= 0 then
        return false
    end
    return true
end

-- Check for alt path blind items
function Epic:AltBlindCheck(entity, item, roomItems)
    if EpicSettings["BlindBypass"] then
        return true
    end

    local result = false
    -- print(item.Name)
    -- print(entity.Position)
    local centerX = 320
    local centerY = 280

    -- two items
    if roomItems == 2 then
        if (entity.Position).X <= centerX and (entity.Position).Y <= centerY then
            -- print("not blind")
            result = true
        end
        -- three items
    elseif roomItems > 2 then
        if (entity.Position).X <= centerX and not ((entity.Position).Y == centerY and (entity.Position).X == centerX) then
            -- print("not blind")
            result = true
        end
    end
    return result
end

---------------------------------------------------------------

local lastItemCount = 0
-- Item/Card update
function Epic:OnRoomUpdate()
    -- i don't know what i'm doing
    lastItemCount = 0
    local currentItemCount = Epic:ScanItems()
    Epic:OnPogMoment(currentItemCount)
end
-- Room update
function Epic:OnNewRoom()
    lastItemCount = 0
    Epic:DoCostume(false)
end

-- Game update
function Epic:OnGameUpdate()

    local currentItemCount = Epic:ScanItems()

    if currentItemCount > lastItemCount then
        lastItemCount = currentItemCount
        Epic:OnPogMoment(currentItemCount)
    elseif currentItemCount < lastItemCount then
        Epic:OnRoomUpdate()
    end

end

Epic:AddCallback(ModCallbacks.MC_POST_UPDATE, Epic.OnGameUpdate)
Epic:AddCallback(ModCallbacks.MC_POST_NEW_ROOM, Epic.OnNewRoom)
Epic:AddCallback(ModCallbacks.MC_USE_ITEM, Epic.OnRoomUpdate)
Epic:AddCallback(ModCallbacks.MC_USE_CARD, Epic.OnRoomUpdate)
